#include <Ethernet.h>
#include <ClientUDP.h>

byte mac[] = { 0x00, 0x1D, 0x60, 0xAF, 0x03, 0x31 };
byte ip[]  = { 192, 168, 0, 3 };
byte gw[] = { 192, 168, 0, 1 };
byte subnet[] = { 255, 255, 255, 0 };

byte buttons[] = {7,6,5};
byte states[] = {HIGH,HIGH,HIGH};

#define PORT  2222

byte ip_to[] = {192,168,0,2};
uint16_t port_to = PORT;
byte buffer[2];

ClientUDP udp(ip_to,port_to);

void setup() {
  pinMode(4,OUTPUT); 
  digitalWrite(4,HIGH);
  for (int i=0;i<sizeof(buttons);i++) { 
    pinMode(buttons[i],INPUT);
    digitalWrite(buttons[i],HIGH);
    states[i] = digitalRead(buttons[i]);
  }  
  Ethernet.begin(mac, ip, gw, subnet);  
  udp.open(PORT);
}

void loop() {
  for (int i=0;i<sizeof(buttons);i++) { 
    byte s = digitalRead(buttons[i]);
    if (s != states[i]) {      
      states[i] = s;
      buffer[0] = i;
      buffer[1] = !s;
      udp.write(buffer,sizeof(buffer));
    }    
  }
  delay(1);
}
